#include <stdio.h>
#include <errno.h>
#include <X11/Xlib.h>
#include <X11/XKBlib.h>

int main()
{
    int major = XkbMajorVersion, minor = XkbMinorVersion;
    XkbDescPtr pKBDesc;
    Display *pDisplay = XkbOpenDisplay(NULL, NULL, NULL, &major, &minor,
                                       NULL);
    if (!pDisplay)
        error(1, 0, "failed to open the display");
    pKBDesc = XkbGetKeyboard(pDisplay, XkbAllComponentsMask, XkbUseCoreKbd);
    if (!pKBDesc)
        error(1, 0, "could not obtain keyboard descriptor");
    if (XkbGetNames(pDisplay, XkbKeyNamesMask, pKBDesc) != Success)
        error(1, 0, "could not update keyboard descriptor");
    {
        int i, j;
        for (i = 0; i < 64; ++i)
        {
            for (j = 0; j < 4; ++j)
            {
                int index = i * 4 + j;
                if (index < pKBDesc->max_key_code)
                    printf("%4d: %8.4s", index, &pKBDesc->names->keys->name[index * 4]);
                if (index + 1 < pKBDesc->max_key_code)
                    printf(", ");
            }
            if (i * 4 < pKBDesc->max_key_code)
                printf("\n");
        }
    }
    XkbFreeNames(pKBDesc, XkbKeyNamesMask, True);
    XkbFreeKeyboard(pKBDesc, XkbAllComponentsMask, True);
    return 0;
}
